SUBROUTINE supercell_struct(acell,alpha,pos,ndif,ncell)
  IMPLICIT NONE
  INTEGER,INTENT(IN)    :: ncell(3)
  INTEGER,INTENT(INOUT) :: ndif
  REAL(8),INTENT(INOUT) :: acell(3)
  REAL(8),INTENT(IN)    :: alpha(3)
  REAL(8),POINTER       :: pos2(:,:)
  INTEGER               :: i1,i2,i3,na,index
  ALLOCATE(pos2(3,ndif*ncell(1)*ncell(2)*ncell(3)))
  index=0
  DO na = 1, ndif
     pos(1,na) = pos(1,na) / REAL(ncell(1))
     pos(2,na) = pos(2,na) / REAL(ncell(2))
     pos(3,na) = pos(3,na) / REAL(ncell(3))
     DO i3 = 0, ncell(3)-1
        DO i2 = 0, ncell(2)-1
           DO i1 = 0, ncell(1)-1
              index=index+1
              pos2(1,index) =pos(1,na)+ real(i1)/real(ncell(1)) 
              pos2(2,index) =pos(2,na)+ real(i2)/real(ncell(2))
              pos2(3,index) =pos(3,na)+ real(i3)/real(ncell(3))
           ENDDO
        ENDDO
     ENDDO
  ENDDO
  DEALLOCATE(pos)
  pos => pos2
  ndif=index
  acell(1)=acell(1)*ncell(1)
  acell(2)=acell(2)*ncell(2)
  acell(3)=acell(3)*ncell(3)
END SUBROUTINE supercell
