#!/usr/bin/perl -w
use strict;
my (@fort,@force0,@force1,@disp,@temp);
my ($case,$pip,$ndir,$pip2,$atom,$nat,$i,$j,$ndisp,$idisp,$fac,$start);
my ($case00);
die "Usage: extract.pl [case] [start]\n" if ($#ARGV < 1);
$case = $ARGV[0];
$start = $ARGV[1];
#$slut = $ARGV[2];
$case00 = 0;

$fac=13.6058/(.529177*1000.);

open(PIP,"DISP2");
$ndisp=0;
while (<PIP>) {
    $ndisp++;
($pip,$disp[0][$ndisp],$disp[1][$ndisp],$disp[2][$ndisp],$disp[3][$ndisp])=unpack("A2A4A12A12A12",$_);
}
close(PIP);
print "$ndisp displacements found in .indisp\n";

#chomp($ndir=<PIP>);
#if($case00 > 0) {
#    chdir("$ndir");
#    open(SCF,"$ndir.scf");
#    $nat=0;
#    while(<SCF>) {
#	if (/:FOR/) {
#	    ($pip,$atom,$pip2,$fort[1],$fort[2],$fort[3])=unpack("A4 A3 A26 A15 A15 A15",$_);
#	    $force0[1][$atom]=$fort[1];
#	    $force0[2][$atom]=$fort[2];
#	    $force0[3][$atom]=$fort[3];
#	    $nat=$atom if($atom>$nat);
#	}
#    }
#    close(SCF);
#    chdir("..");
#}else {
#    $nat=54;
#    for $i (1..54) {
#	$force0[1][$i]=0;
#	$force0[2][$i]=0;
#	$force0[3][$i]=0;
#    }
#}

# READ 

open(STRUCT,"$case.struct");
$pip=<STRUCT>;
($pip,$nat)=unpack("A27A3",<STRUCT>);
close(STRUCT);
#$nat=54;
open(FORCES,">FORCES");
print FORCES "$ndisp\n";
$idisp=0;
for $j (0..$ndisp-1) {
    $ndir=sprintf("CASE_%02i",$j+$start);
    chdir("$ndir");
    $idisp++;
    printf FORCES "%3i %9.5f %9.5f %9.5f\n",$disp[0][$idisp],$disp[1][$idisp],$disp[2][$idisp],$disp[3][$idisp];
    print("$ndir\n");
    open(SCF,"${ndir}.scf");
#    open(SCF,"${ndir}_rk5.3_50k.scf");
    while(<SCF>) {
	if (/:FOR/) {
	    ($pip,$atom,$pip2,$fort[1],$fort[2],$fort[3])=unpack("A4 A3 A26 A15 A15 A15",$_);
	    $force1[1][$atom]=$fort[1];
	    $force1[2][$atom]=$fort[2];
	    $force1[3][$atom]=$fort[3];
	}
    }
    for $i (1..$nat) {
	$force1[1][$i]=$force1[1][$i];
	$force1[2][$i]=$force1[2][$i];
	$force1[3][$i]=$force1[3][$i];
	printf FORCES "%10.6f %10.6f %10.6f\n",$force1[1][$i]*$fac, $force1[2][$i]*$fac, $force1[3][$i]*$fac;
    }
    close(SCF);
    chdir("..");
}
close(FORCES);
close(PIP);
